/*
     ------------------------------------------------
     LIA_SCT: A DECISION-TREE BASED STRING CLASSIFIER
     ------------------------------------------------
 
     Copyright (C) 2001 FREDERIC BECHET
 
     ..................................................................
 
     This file is part of LIA_SCT
 
     LIA_SCT is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
     ..................................................................
 
     For any publication related to scientific work using LIA_SCT,
     the following reference paper must be mentioned in the bibliography: 
         
     Bechet F., Nasr A., Genet F. 2000, "Tagging unknown proper names
     using decision trees", in 38th Annual Meeting of the Association for
     Computational Linguistics (ACL), Hong-Kong, China, 2000, pp. 77-84
     ..................................................................
                               
     Contact :
               FREDERIC BECHET - LIA - UNIVERSITE D'AVIGNON
               AGROPARC BP1228 84911  AVIGNON  CEDEX 09  FRANCE
               frederic.bechet@lia.univ-avignon.fr
     ..................................................................
*/
/*  Compare les modeles : on test chaque fichier de test avec
    tous les modeles et on regarde celui qui marche le mieux
    (pour voir si c'est celui correspondant au test)  */
/*  FRED 0200  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#define TailleLigne	800

#define NB_MAX_MODELE	100

char *TablModele[NB_MAX_MODELE];

int NbModele;

void lis_list_modele(char *nomfic)
{
FILE *file;
char ch[TailleLigne],*pt;

if (!(file=fopen(nomfic,"rt")))
 { fprintf(stderr,"can't open : %s\n",nomfic); exit(0); }

for(NbModele=0;fgets(ch,TailleLigne,file);NbModele++)
 {
 if (NbModele==NB_MAX_MODELE) { fprintf(stderr,"NB_MAX_MODELE trop petit ....\n"); exit(0); }
 pt=strtok(ch," \t\n");
 TablModele[NbModele]=strdup(pt);
 }
fclose(file);
}

void test_modeles()
{
int i,j,choix;
char test[TailleLigne],model[TailleLigne],ch[TailleLigne];
FILE *file;
double pp,entr,best;

for(i=0;i<NbModele;i++)
 {
 sprintf(test,"./NOEUD/noeud_n%s.test",TablModele[i]);
 best=(double)1000; choix=-1;
 for(j=0;j<NbModele;j++)
 /* TEST en ne prenant JAMAIS le modele adequat */
 /*if (i!=j)*/
  {
  sprintf(model,"./NOEUD/noeud_n%s.arpa",TablModele[j]);
  sprintf(ch,"./test_perplexity %s %s > yoyo",test,model);
  system(ch);
  file=fopen("yoyo","rt");
  while(fgets(ch,TailleLigne,file))
   if (!strncmp(ch,"Perplexity",10)) sscanf(ch,"Perplexity = %lf, Entropy = %lf bits",&pp,&entr);
  fclose(file);
  system("rm yoyo");
  if (best>pp) { best=pp; choix=j; }
  printf("Test=%s Model=%s : pp=%.2lf\n",TablModele[i],TablModele[j],pp);
  }
 if (choix==-1) { fprintf(stderr,"pas de pp < 1000 ????\n"); exit(0); }
 printf("\nBEST TEST %s = %s ",TablModele[i],TablModele[choix]);
 if (i==choix) printf("=> OK\n"); else printf("=> ERREUR\n");
 printf("\n................................................................\n\n");
 }
}

int main(int argc,char **argv)
{

if (argc<2)
 {
 fprintf(stderr,"Syntaxe : %s <fich list modele>\n",argv[0]);
 exit(0);
 }

lis_list_modele(argv[1]);
test_modeles();

}
  
