/*
     ------------------------------------------------
     LIA_SCT: A DECISION-TREE BASED STRING CLASSIFIER
     ------------------------------------------------
 
     Copyright (C) 2001 FREDERIC BECHET
 
     ..................................................................
 
     This file is part of LIA_SCT
 
     LIA_SCT is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
     ..................................................................
 
     For any publication related to scientific work using LIA_SCT,
     the following reference paper must be mentioned in the bibliography: 
         
     Bechet F., Nasr A., Genet F. 2000, "Tagging unknown proper names
     using decision trees", in 38th Annual Meeting of the Association for
     Computational Linguistics (ACL), Hong-Kong, China, 2000, pp. 77-84
     ..................................................................
                               
     Contact :
               FREDERIC BECHET - LIA - UNIVERSITE D'AVIGNON
               AGROPARC BP1228 84911  AVIGNON  CEDEX 09  FRANCE
               frederic.bechet@lia.univ-avignon.fr
     ..................................................................
*/
/*  Take as input a corpus feuille file produced
    by 'lia_sct_use -corpus_feuille' with MODIF
    HMIHY 03/21/02 which write the filename in
    front of each sentence separated by a \t
    and copy each sentence in its corresponding
    file. WARNING: THE FILE MUST BE SORTED  */
/*  FRED 0302  */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

/*................................................................*/

#define TailleLigne	10000

#define True	1
#define False	0

#define max(a,b)        ((a)>(b)?(a):(b))
#define min(a,b)        ((a)<(b)?(a):(b))

void ERREUR(char *ch1,char *ch2)
{
fprintf(stderr,"ERREUR : %s %s\n",ch1,ch2);
exit(0);
}

/*................................................................*/

int main(int argc, char **argv)
{
char ch[TailleLigne],filename[TailleLigne],*pt;
int nb;
FILE *file=NULL;
fprintf(stderr,"=> writing leaves\n");
filename[0]='\0';
for(nb=0;fgets(ch,TailleLigne,stdin);nb++)
 {
 if ((nb+1)%5000==0) fprintf(stderr,"En cours : %d\n",nb+1);
 pt=strtok(ch,"\t");
 if (strcmp(pt,filename))
  {
  if (file) fclose(file);
  strcpy(filename,pt);
  if (!(file=fopen(filename,"a"))) ERREUR("can't write in:",filename);
  }
 pt=strtok(NULL," \t\n");
 fprintf(file,"%s",pt);
 for(pt=strtok(NULL," \t\n");pt;pt=strtok(NULL," \t\n"))
  {
  if (!strcmp(pt,"&&&&")) fprintf(file,"\n&");
  else fprintf(file," %s",pt);
  }
 fprintf(file,"\n");
 }
if (file) fclose(file);

fprintf(stderr,"   all done\n");
}
 
